<?xml version="1.0" ?>

<TestCase name="VSEChecker" version="5">

<meta>
   <create version="10.1.0" buildNumber="10.1.0.243" author="admin" date="04/18/2017" host="NESJO02" />
   <lastEdited version="10.1.0" buildNumber="10.1.0.243" author="admin" date="04/18/2017" host="NESJO02" />
</meta>

<id>58C11679244211E79E838CCD20524153</id>
<Documentation>Put documentation of the Test Case here.</Documentation>
<IsInProject>true</IsInProject>
<sig>ZWQ9NSZ0Y3Y9LTEmbGlzYXY9MTAuMS4wICgxMC4xLjAuMjQzKSZub2Rlcz0tNjgzNzA5NjUy</sig>
<subprocess>false</subprocess>

<initState>
</initState>

<resultState>
</resultState>

    <Node name="REST Call to Invoke API" log=""
          type="com.itko.lisa.ws.rest.RESTNode" 
          version="3" 
          uid="5D9C86ED244211E79E838CCD20524153" 
          think="0" 
          useFilters="true" 
          quiet="false" 
          next="Extract Svc Details for Row" > 


      <!-- Filters -->
      <Filter type="com.itko.lisa.test.FilterSaveResponse">
        <valueToFilterKey>lisa.REST Call to Invoke API.rsp</valueToFilterKey>
      <prop>fl_response</prop>
      </Filter>

      <Filter type="com.itko.lisa.xml.FilterXMLXPath">
        <valueToFilterKey>lisa.REST Call to Invoke API.rsp</valueToFilterKey>
<prop>fl_svcListCnt</prop>
<xpathq>count(/:Vse/:VirtualServiceList/:VirtualService)</xpathq>
<nsMap0>=http://www.ca.com/lisa/invoke/v2.0</nsMap0>
<nsMap1>xsi=http://www.w3.org/2001/XMLSchema-instance</nsMap1>
      </Filter>


      <!-- Assertions -->
<CheckResult assertTrue="true" name="svcListCnt 0 ends the test" type="com.itko.lisa.test.CheckResultPropRegEx">
<log></log>
<then>end</then>
        <prop>fl_svcListCnt</prop>
        <param>0</param>
</CheckResult>

<url>http://admin:admin@localhost:1505/api/Dcm/VSEs/VSE</url>
<content-type></content-type>
<data-type>text</data-type>
<httpMethod>GET</httpMethod>
<onError>abort</onError>
<encode-test-props-in-url>true</encode-test-props-in-url>
    </Node>


    <Node name="Extract Svc Details for Row" log=""
          type="com.itko.lisa.test.NoTransNode" 
          version="1" 
          uid="623C8016244311E79E838CCD20524153" 
          think="0-1" 
          useFilters="true" 
          quiet="true" 
          next="Examine Each Svc for Errors" > 


      <!-- Filters -->
      <Filter type="com.itko.lisa.xml.FilterXMLXPath">
        <valueToFilterKey>lisa.http GET /api/Dcm/VSEs/VSE.rsp</valueToFilterKey>
<prop>fl_svcName</prop>
<xpathq>/:Vse/:VirtualServiceList/:VirtualService[{{dsIndex}}]/:ModelName/text()</xpathq>
<nsMap0>=http://www.ca.com/lisa/invoke/v2.0</nsMap0>
<nsMap1>xsi=http://www.w3.org/2001/XMLSchema-instance</nsMap1>
      </Filter>

      <Filter type="com.itko.lisa.xml.FilterXMLXPath">
        <valueToFilterKey>lisa.http GET /api/Dcm/VSEs/VSE.rsp</valueToFilterKey>
<prop>fl_svcStatus</prop>
<xpathq>/:Vse/:VirtualServiceList/:VirtualService[{{dsIndex}}]/:Status/text()</xpathq>
<nsMap0>=http://www.ca.com/lisa/invoke/v2.0</nsMap0>
<nsMap1>xsi=http://www.w3.org/2001/XMLSchema-instance</nsMap1>
      </Filter>

      <Filter type="com.itko.lisa.xml.FilterXMLXPath">
        <valueToFilterKey>lisa.http GET /api/Dcm/VSEs/VSE.rsp</valueToFilterKey>
<prop>fl_svcErrorCnt</prop>
<xpathq>/:Vse/:VirtualServiceList/:VirtualService[{{dsIndex}}]/:ErrorCount/text()</xpathq>
<nsMap0>=http://www.ca.com/lisa/invoke/v2.0</nsMap0>
<nsMap1>xsi=http://www.w3.org/2001/XMLSchema-instance</nsMap1>
      </Filter>


      <!-- Data Sets -->
<readrec>Numeric Counting DS</readrec>
    </Node>


    <Node name="Examine Each Svc for Errors" log=""
          type="com.itko.lisa.test.UserScriptNode" 
          version="1" 
          uid="7EB8DE04244411E79E838CCD20524153" 
          think="0-1" 
          useFilters="true" 
          quiet="false" 
          next="Extract Svc Details for Row" > 


      <!-- Assertions -->
<CheckResult assertTrue="true" name="Any Exception Then Fail" type="com.itko.lisa.dynexec.CheckInvocationEx">
<log>Assertion name: Any Exception Then Fail checks for: true is of type: Assert on Invocation Exception.</log>
<then>fail</then>
<valueToAssertKey></valueToAssertKey>
        <param>.*</param>
</CheckResult>

<onerror>abort</onerror>
<language>BeanShell</language>
<copyProps>TestExecProps</copyProps>
<script>//&#13;&#10;String svcName   = testExec.getStateString( &quot;fl_svcName&quot;, &quot;&quot; ); &#13;&#10;String svcState  = testExec.getStateString( &quot;fl_svcStatus&quot;, &quot;&quot; );&#13;&#10;String svcErrors = testExec.getStateString(&quot;fl_svcErrorCnt&quot;, &quot;0&quot; ); &#13;&#10;String msg       = testExec.getStateString( &quot;fl_errorMsg&quot;, &quot;&quot; );&#13;&#10;&#13;&#10;&#13;&#10;// no service name is not good&#13;&#10;if ( &quot;&quot;.equals( svcName) ) {&#13;&#10;    return &quot;Encountered empty service name&quot;;&#13;&#10;}&#13;&#10;&#13;&#10;// Service is not running&#13;&#10;if ( Integer.parseInt( svcErrors ) == 0 ) {&#13;&#10;    return &quot;No Errors for service: &quot; + svcName;&#13;&#10;}&#13;&#10;&#13;&#10;// The status of the virtual service: &#13;&#10;// &quot;0&quot;, the virtual service has been created, but not initialized yet; &#13;&#10;// &quot;1&quot;, the virtual service is in its startup sequence; &#13;&#10;// &quot;2&quot;, the virtual service is up and running; &#13;&#10;// &quot;3&quot;, the virtual service is in its shutdown sequence; &#13;&#10;// &quot;4&quot;, the virtual service has been shut down; &#13;&#10;// &quot;5&quot;, a virtual service is registered but cannot be run&#13;&#10;if ( &quot;0&quot;.equals( svcState ) ) {&#13;&#10;     msg = msg + &quot;\nService: &quot; + svcName + &quot; is created and has: &quot; + svcErrors + &quot; errors&quot;;&#13;&#10;} else if ( &quot;1&quot;.equals( svcState ) ) {&#13;&#10;         msg = msg + &quot;\nService: &quot; + svcName + &quot; is in start up and has: &quot; + svcErrors + &quot; errors&quot;;&#13;&#10;} else if ( &quot;2&quot;.equals( svcState ) ) {&#13;&#10;         msg = msg + &quot;\nService: &quot; + svcName + &quot; is running but shows: &quot; + svcErrors + &quot; errors&quot;;&#13;&#10;} else if ( &quot;3&quot;.equals( svcState ) ) {&#13;&#10;         msg = msg + &quot;\nService: &quot; + svcName + &quot; in shutdown sequence but showing: &quot; + svcErrors + &quot; errors&quot;;&#13;&#10;} else if ( &quot;4&quot;.equals( svcState ) ) {&#13;&#10;         msg = msg + &quot;\nService: &quot; + svcName + &quot; has been shutdown and shows: &quot; + svcErrors + &quot; errors&quot;;&#13;&#10;} else if ( &quot;5&quot;.equals( svcState ) ) {&#13;&#10;         msg = msg + &quot;\nService: &quot; + svcName + &quot; is registered, cannot be run, and shows: &quot; + svcErrors + &quot; errors&quot;;&#13;&#10;} else {   &#13;&#10;         msg = msg + &quot;\nService: &quot; + svcName + &quot; is showing unknown status of: &quot; + svcState + &quot; and shows: &quot; + svcErrors + &quot; errors&quot;;&#13;&#10;}&#13;&#10;    &#13;&#10;testExec.setStateValue( &quot;fl_errorMsg&quot;, msg );&#13;&#10;&#13;&#10;return &quot;Errors reported for: &quot; + svcName;</script>
    </Node>


    <Node name="Send Mail or Not" log=""
          type="com.itko.lisa.test.UserScriptNode" 
          version="1" 
          uid="A5081402244611E79E838CCD20524153" 
          think="0-1" 
          useFilters="true" 
          quiet="false" 
          next="end" > 


      <!-- Assertions -->
<CheckResult assertTrue="true" name="Any Exception Then Fail" type="com.itko.lisa.dynexec.CheckInvocationEx">
<log>Assertion name: Any Exception Then Fail checks for: true is of type: Assert on Invocation Exception.</log>
<then>fail</then>
<valueToAssertKey></valueToAssertKey>
        <param>.*</param>
</CheckResult>

<CheckResult assertTrue="true" name="Assert Send Email or End Test" type="com.itko.lisa.test.CheckResultRegEx">
<log></log>
<then>Send Email Step</then>
        <param>true</param>
</CheckResult>

<onerror>abort</onerror>
<language>BeanShell</language>
<copyProps>TestExecProps</copyProps>
<script>//&#13;&#10;if ( &quot;&quot;.equals( testExec.getStateString( &quot;fl_errorMsg&quot;, &quot;&quot; ) ) )&#13;&#10;    return &quot;false&quot;;&#13;&#10;else&#13;&#10;    return &quot;true&quot;;&#13;&#10;</script>
    </Node>


    <Node name="Send Email Step" log=""
          type="com.itko.lisa.glass.SendEmailStep" 
          version="1" 
          uid="EEA3EB35244611E79E838CCD20524153" 
          think="500-1S" 
          useFilters="true" 
          quiet="false" 
          next="end" > 

<EmailConnection>
</EmailConnection>
<Bcc></Bcc>
<Cc></Cc>
<From>devTest@yourCo.com</From>
<Message>{{fl_errorMsg}}</Message>
<Subject>Virtual Services are Down</Subject>
<To>someone@yourCo.com</To>
<onError>abort</onError>
    </Node>


    <Node name="end" log=""
          type="com.itko.lisa.test.NormalEnd" 
          version="1" 
          uid="58C1167F244211E79E838CCD20524153" 
          think="0h" 
          useFilters="true" 
          quiet="true" 
          next="fail" > 

    </Node>


    <Node name="fail" log=""
          type="com.itko.lisa.test.Abend" 
          version="1" 
          uid="58C1167D244211E79E838CCD20524153" 
          think="0h" 
          useFilters="true" 
          quiet="true" 
          next="abort" > 

    </Node>


    <Node name="abort" log=""
          type="com.itko.lisa.test.AbortStep" 
          version="1" 
          uid="58C1167B244211E79E838CCD20524153" 
          think="0h" 
          useFilters="true" 
          quiet="true" 
          next="" > 

    </Node>


    <DataSet type="com.itko.lisa.test.CounterDataSet" name="Numeric Counting DS" atend="Send Mail or Not" local="true" random="false" maxItemsToFetch="0" >
    <propKey>dsIndex</propKey>
    <countFrom>1</countFrom>
    <countTo>{{fl_svcListCnt}}</countTo>
    <countIncrement>1</countIncrement>
    </DataSet>

</TestCase>
